diff --git a/src/main/java/net/minecraft/client/render/RenderEngine.java b/src/main/java/net/minecraft/client/render/RenderEngine.java
index e9fed0614..3de2fa842 100644
--- a/src/main/java/net/minecraft/client/render/RenderEngine.java
+++ b/src/main/java/net/minecraft/client/render/RenderEngine.java
@@ -6,25 +6,20 @@ import static org.lwjgl.opengl.GL11.*;
 import static org.lwjgl.opengl.GL12.*;
 
 import java.awt.image.BufferedImage;
-import java.io.InputStream;
 import java.nio.ByteBuffer;
 import java.util.ArrayList;
-import java.util.Collections;
 import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
-
-import com.b100.json.element.JsonArray;
-import com.b100.json.element.JsonElement;
-import com.b100.json.element.JsonObject;
+import java.util.Objects;
 
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.popup.GuiPopup;
 import net.minecraft.client.gui.popup.PopupBuilder;
 import net.minecraft.client.option.GameSettings;
-import net.minecraft.client.option.enums.MipmapType;
 import net.minecraft.client.render.colorizer.Colorizers;
+import net.minecraft.client.render.customatlas.CustomAtlasHandler;
 import net.minecraft.client.render.dynamictexture.DynamicTexture;
 import net.minecraft.client.render.dynamictexture.DynamicTextureCalendar;
 import net.minecraft.client.render.dynamictexture.DynamicTextureClock;
@@ -38,32 +33,36 @@ import net.minecraft.client.render.dynamictexture.DynamicTexturePortal;
 import net.minecraft.client.render.dynamictexture.DynamicTextureTrommel;
 import net.minecraft.client.render.dynamictexture.DynamicTextureWaterFlow;
 import net.minecraft.client.render.dynamictexture.DynamicTextureWaterStill;
-import net.minecraft.client.render.stitcher.AtlasStitcher;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
-import net.minecraft.client.render.texturepack.TexturePack;
+import net.minecraft.client.render.texture.meta.AnimationProperties;
+import net.minecraft.client.render.texture.stitcher.AtlasStitcher;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.BufferedTexture;
+import net.minecraft.client.render.texture.DownloadedTexture;
+import net.minecraft.client.render.texture.FileTexture;
+import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.render.texturepack.TexturePackException;
 import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.client.util.helper.Colors;
-import net.minecraft.client.util.helper.TexturePackJsonHelper;
 import net.minecraft.client.util.helper.Textures;
+import net.minecraft.core.block.material.MaterialColor;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.Buffer;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.opengl.GL11;
 
 public class RenderEngine {
 
-	public static boolean debugMipmap = false;
-	private static boolean fixArtifacts = true;
-	
 	public final Minecraft mc;
-	
-	private Map<String, Integer> textureMap = new HashMap<>();
-	private Map<String, int[]> intArrayTextureData = new HashMap<>();
-	private Map<Integer, BufferedImage> textureNameToImageMap = new HashMap<>();
-	private Map<String, DownloadedTexture> downloadedTextures = new HashMap<>();
 
-	private List<DynamicTexture> dynamicTextures = new ArrayList<>();
+	public final Map<Integer, Texture> idToTextureMap = new HashMap<>();
+	public final Map<String, Texture> textureMap = new HashMap<>();
+	public final List<BufferedTexture> bufferedTextures = new ArrayList<>();
+	public final Map<String, DownloadedTexture> downloadedTextures = new HashMap<>();
+	public final Map<NamespaceID, DynamicTexture> dynamicTextures = new HashMap<>();
 	
-	private GameSettings gameSettings;
+	private final GameSettings gameSettings;
 	public TexturePackList texturePacks;
 	
 	private boolean clampTexture;
@@ -85,377 +84,94 @@ public class RenderEngine {
 		dynamicTextures.clear();
 
 		if (mc.gameSettings.animations.value != 0) {
-			TexturePack tp;
-
 			boolean useCustomAnimations = mc.gameSettings.animations.value == 2;
 
 			try {
-				tp = mc.texturePackList.getHighestPriorityTexturePackWithFile("/anim/custom_water_still.png");
-				if(useCustomAnimations && tp != null) {
-					dynamicTextures.add(new DynamicTextureCustom(mc, tp, "/anim/custom_water_still.png", "minecraft:block/water_still", false));
-				}else {
-					dynamicTextures.add(new DynamicTextureWaterStill());
-				}
-
-				tp = mc.texturePackList.getHighestPriorityTexturePackWithFile("/anim/custom_water_flowing.png");
-				if(useCustomAnimations && tp != null) {
-					dynamicTextures.add(new DynamicTextureCustom(mc, tp, "/anim/custom_water_flowing.png", "minecraft:block/water_flowing", true));
-				}else {
-					dynamicTextures.add(new DynamicTextureWaterFlow());
-				}
-
-				tp = mc.texturePackList.getHighestPriorityTexturePackWithFile("/anim/custom_lava_still.png");
-				if(useCustomAnimations && tp != null) {
-					dynamicTextures.add(new DynamicTextureCustom(mc, tp, "/anim/custom_lava_still.png", "minecraft:block/lava_still", false));
-				}else {
-					dynamicTextures.add(new DynamicTextureLavaStill());
+                addDynamicTexture(new DynamicTextureWaterStill(TextureRegistry.getTexture("minecraft:block/water_still")));
+                addDynamicTexture(new DynamicTextureWaterFlow(TextureRegistry.getTexture("minecraft:block/water_flowing")));
+                addDynamicTexture(new DynamicTextureLavaStill(TextureRegistry.getTexture("minecraft:block/lava_still")));
+                addDynamicTexture(new DynamicTextureLavaFlowing(TextureRegistry.getTexture("minecraft:block/lava_flowing")));
+                addDynamicTexture(new DynamicTexturePortal(TextureRegistry.getTexture("minecraft:block/portal_nether"),false));
+                addDynamicTexture(new DynamicTextureFire(TextureRegistry.getTexture("minecraft:block/fire")));
+
+                String[] fireflycolors = new String[] {"blue", "orange", "green", "red"};
+				for (String color : fireflycolors) {
+					addDynamicTexture(new DynamicTextureFireflyJar(TextureRegistry.getTexture("minecraft:block/lantern_firefly_" + color)));
 				}
 
-				tp = mc.texturePackList.getHighestPriorityTexturePackWithFile("/anim/custom_lava_flowing.png");
-				if(useCustomAnimations && tp != null) {
-					dynamicTextures.add(new DynamicTextureCustom(mc, tp, "/anim/custom_lava_flowing.png", "minecraft:block/lava_flowing", true));
-				}else {
-					dynamicTextures.add(new DynamicTextureLavaFlowing());
-				}
-
-				tp = mc.texturePackList.getHighestPriorityTexturePackWithFile("/anim/custom_portal.png");
-				if(useCustomAnimations && tp != null) {
-					dynamicTextures.add(new DynamicTextureCustom(mc, tp, "/anim/custom_portal.png", "minecraft:block/portal_nether", false));
-				}else {
-					dynamicTextures.add(new DynamicTexturePortal(false));
-				}
-
-				tp = mc.texturePackList.getHighestPriorityTexturePackWithFile("/anim/custom_fire.png");
-				if(useCustomAnimations && tp != null) {
-					dynamicTextures.add(new DynamicTextureCustom(mc, tp, "/anim/custom_fire.png", "minecraft:block/fire", false));
-				}else {
-					dynamicTextures.add(new DynamicTextureFire());
-				}
-
-				String[] fireflycolors = new String[] {"blue", "orange", "green", "red"};
-				for(int i=0; i < 4; i++) {
-					String color = fireflycolors[i];
+				addDynamicTexture(new DynamicTextureTrommel(mc, TextureRegistry.getTexture("minecraft:block/trommel_active_front"), true));
+				addDynamicTexture(new DynamicTextureTrommel(mc, TextureRegistry.getTexture("minecraft:block/trommel_active_back"), false));
 
-					String animationPath = "/anim/custom_firefly_jar_" + color + ".png";
-					String texturePath = "/assets/minecraft/textures/block/lantern_firefly_" + color + ".png";
-					String textureName = "minecraft:block/lantern_firefly_" + color;
-
-					tp = mc.texturePackList.getHighestPriorityTexturePackWithFile(animationPath);
-					if(useCustomAnimations && tp != null) {
-						dynamicTextures.add(new DynamicTextureCustom(mc, tp, animationPath, textureName, false));
-					}else {
-						dynamicTextures.add(new DynamicTextureFireflyJar(mc, texturePath, textureName));
-					}
+				if (useCustomAnimations) {
+					loadCustomAnimations();
 				}
-
 			}catch (TexturePackException e) {
 				errors.add(e);
 			}
-
-			tp = mc.texturePackList.getHighestPriorityTexturePackWithFile("/anim/animations.json");
-			if(useCustomAnimations && tp != null) {
-				loadCustomAnimations(tp, errors);
-			}
-
-			dynamicTextures.add(new DynamicTextureTrommel(mc, TextureRegistry.getTexture("minecraft:block/trommel_active_front"), true));
-			dynamicTextures.add(new DynamicTextureTrommel(mc, TextureRegistry.getTexture("minecraft:block/trommel_active_back"), false));
 		}
 
-        dynamicTextures.add(new DynamicTextureClock(mc));
-		dynamicTextures.add(new DynamicTextureCalendar(mc));
-		dynamicTextures.add(new DynamicTextureCompass(mc));
+        addDynamicTextureOverride(new DynamicTextureClock(mc), true);
+		addDynamicTextureOverride(new DynamicTextureCalendar(mc), true);
+		addDynamicTextureOverride(new DynamicTextureCompass(mc, TextureRegistry.getTexture("minecraft:item/tool_compass")), true);
 	}
-	
-	private void loadCustomAnimations(TexturePack tp, List<Throwable> errors) {
+
+	protected void addDynamicTexture(DynamicTexture texture) {
+		addDynamicTextureOverride(texture, false);
+	}
+	protected void addDynamicTextureOverride(DynamicTexture texture, boolean override) {
+		if (!override && dynamicTextures.containsKey(texture.targetTexture.namespaceId)) return;
+		dynamicTextures.put(texture.targetTexture.namespaceId, texture);
+	}
+
+	private void loadCustomAnimations() {
 		if(!mc.gameSettings.customAnimations.value) {
 			return;
 		}
-		try {
-			List<DynamicTexture> customAnimations = new ArrayList<>();
 
-			JsonObject rootObject = TexturePackJsonHelper.readJsonObject(tp, "/anim/animations.json");
-			JsonArray animations = TexturePackJsonHelper.getArray(rootObject, "animations");
-			try {
-				for(int i=0; i < animations.length(); i++) {
-					JsonElement element = animations.get(i);
-					if(!element.isObject()) {
-						throw new TexturePackException("Index "+i+" is not an object!");
-					}
-
-					try {
-						JsonObject animationObject = element.getAsObject();
-
-                        String id = TexturePackJsonHelper.getString(animationObject, "id");
-						String name = TexturePackJsonHelper.getString(animationObject, "name");
-						
-						String animationSource = "/anim/" + name + ".png";
-						if(!tp.hasFile(animationSource)) {
-							throw new TexturePackException("File '"+animationSource+"' does not exist!");
-						}
-						
-						customAnimations.add(new DynamicTextureCustom(mc, tp, animationSource, id, false));
-					}catch (TexturePackException e) {
-						throw new TexturePackException("Error at index " + i, e);
-					}
+		for (AtlasStitcher stitcher : TextureRegistry.stitcherMap.values()){
+			for (IconCoordinate c : stitcher.textureMap.values()) {
+				if (c.hasMeta("animation")) {
+					System.out.println("Icon '" + c.namespaceId + "' has 'animation' meta!");
+					addDynamicTextureOverride(new DynamicTextureCustom(c, c.getMeta("animation", AnimationProperties.class)), true);
 				}
-			}catch (Exception e) {
-				throw new TexturePackException("Error in animations.json", e);
 			}
-
-			this.dynamicTextures.addAll(customAnimations);
-		}catch (Exception e) {
-			errors.add(e);
 		}
 	}
-	
-	public int[] getTextureImageData(String name) {
-		int[] imageData = intArrayTextureData.get(name);
-		if (imageData != null) return imageData;
-		
-		imageData = getImageData(readImage(texturePacks.getResourceAsStream(name)));
-		if(imageData == null) imageData = getImageData(missingTexture);
+
+	public @NotNull Texture loadTexture(@NotNull final String name) {
+		Texture t = loadTextureNoDefault(name);
 		
-		intArrayTextureData.put(name, imageData);
-		return imageData;
-	}
+		if (t == null) {
+			t = new BufferedTexture(missingTexture, false, false, false);
+			textureMap.put(name, t);
+			idToTextureMap.put(t.id(), t);
+        }
+        return t;
+    }
 
-	public int getTexture(String name) {
-		if(name == null) throw new NullPointerException();
+	public @Nullable Texture loadTextureNoDefault(@NotNull final String name) {
+		Objects.requireNonNull(name);
+
+		Texture texture = textureMap.get(name);
+		if (texture != null) return texture;
 
-		Integer id = textureMap.get(name);
-		if (id != null) return id;
-		
 		try {
-			id = GLAllocation.generateTexture();
-			
-			if (name.startsWith("##")) {
-				setupTexture(unwrapImageByColumns(readImage(texturePacks.getResourceAsStream(name.substring(2)))), id);
-			} else if (name.startsWith("%clamp%")) {
-				clampTexture = true;
-				setupTexture(readImage(texturePacks.getResourceAsStream(name.substring(7))), id);
-				clampTexture = false;
-			} else if (name.startsWith("%blur%")) {
-				blurTexture = true;
-				setupTexture(readImage(texturePacks.getResourceAsStream(name.substring(6))), id);
-				blurTexture = false;
-			} else {
-				InputStream inputstream = texturePacks.getResourceAsStream(name);
-				if (inputstream == null) {
-					setupTexture(missingTexture, id);
-				} else {
-					setupTexture(readImage(inputstream), id);
-				}
-			}
-			textureMap.put(name, id);
-			return id;
+			texture = new FileTexture(name);
+			textureMap.put(name, texture);
+			idToTextureMap.put(texture.id(), texture);
+			return texture;
 		} catch (Exception e) {
 			e.printStackTrace();
 		}
-		
-		int j = GLAllocation.generateTexture();
-		setupTexture(missingTexture, j);
-		textureMap.put(name, j);
-		return j;
+		return null;
 	}
 
-	public int allocateAndSetupTexture(BufferedImage bufferedimage) {
-		int i = GLAllocation.generateTexture();
-		setupTexture(bufferedimage, i);
-		textureNameToImageMap.put(i, bufferedimage);
-		return i;
-	}
-	
-	public void setupTexture(BufferedImage img, int id) {
-		setupTexture(img, id, false);
-	}
-	
-	public void setupTexture(BufferedImage img, int id, boolean mipmap) {
-		glBindTexture(GL_TEXTURE_2D, id);
-		
-		if(blurTexture) {
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
-		}else {
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
-		}
-		
-		if(clampTexture) {
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
-		}else {
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
-		}
-		
-		int w = img.getWidth();
-		int h = img.getHeight();
-		
-		Buffer.put(img);
-		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, w, h, 0, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
-		
-		if(mipmap) {
-			generateMipmaps(buffer, img, mc.gameSettings.mipmapLevels.value, mc.gameSettings.mipmapType.value == MipmapType.SMOOTH);
-		}
+	public BufferedTexture loadBufferedTexture(BufferedImage bufferedimage) { // TODO, this may need a way to reduce textures from the same BufferedImage, since this allocates a new texture to memory every time its called
+		BufferedTexture texture = new BufferedTexture(bufferedimage, false, false, false);
+		bufferedTextures.add(texture);
+		return texture;
 	}
-	
-	private void generateMipmaps(ByteBuffer buffer, BufferedImage image, int levels, boolean smooth) {
-		System.out.println("Generating Mipmaps...");
-		
-		final int width = image.getWidth();
-		final int height = image.getHeight();
-		
-		int[] data = new int[width * height];
-		int[] newData = null;
-		
-		for(int x=0; x < width; x++) {
-			for(int y=0; y < height; y++) {
-				data[width * y + x] = image.getRGB(x, y);
-			}
-		}
-		
-		if(fixArtifacts) {
-			for(int level = levels; level > 0; level--) {
-				int lod = (int) Math.pow(2, level);
-				
-				int tilesX = width / lod;
-				int tilesY = height / lod;
-				
-				for(int x = 0; x < tilesX; x++) {
-					for(int y = 0; y < tilesY; y++) {
-						
-						Integer nonTransparentColor = null;
-						
-						getColor: for(int i=0; i < lod; i++) {
-							for(int j=0; j < lod; j++) {
-								int x0 = x * lod + i;
-								int y0 = y * lod + j;
-								
-								int color = data[width * y0 + x0];
-
-								if(((color >> 24) & 0xFF) > 0) {
-									nonTransparentColor = color;
-									break getColor;
-								}
-							}
-						}
-						
-						if(nonTransparentColor != null) {
-							nonTransparentColor &= 0x00FFFFFF;
-							
-							for(int i=0; i < lod; i++) {
-								for(int j=0; j < lod; j++) {
-									int x0 = x * lod + i;
-									int y0 = y * lod + j;
-									
-									int color = data[width * y0 + x0];
-
-									if(((color >> 24) & 0xFF) == 0) {
-										data[width * y0 + x0] = nonTransparentColor;
-									}
-								}
-							}	
-						}			
-					}
-				}
-			}
-		}
-		
-		int previousWidth = width;
-		int newWidth = width;
-		int newHeight = height;
-		
-		for(int level = 0; level <= levels; level++) {
-			newData = new int[newWidth * newHeight];
-
-			for(int y = 0; y < newWidth; y++) {
-				for(int x = 0; x < newHeight; x++) {
-					int color;
-					
-					if(level == 0) {
-						color = data[width * y + x];
-					}else {
-						int x1 = x << 1;
-						int y1 = y << 1;
-						
-						if(smooth) {
-							int color0 = data[previousWidth * (y1 + 0) + (x1 + 0)];
-							int color1 = data[previousWidth * (y1 + 0) + (x1 + 1)];
-							int color2 = data[previousWidth * (y1 + 1) + (x1 + 0)];
-							int color3 = data[previousWidth * (y1 + 1) + (x1 + 1)];
-							
-							color = blendColor(blendColor(color0, color1), blendColor(color2, color3));
-						}else {
-							color = data[previousWidth * y1 + x1];
-						}
-					}
-					
-					newData[y * newWidth + x] = color;
-				}
-			}
-			
-			buffer.position(0).limit(buffer.capacity());
-			
-			for(int i=0; i < newData.length; i++) {
-				int color = newData[i];
-
-				buffer.put((byte) ((color >> 16) & 0xFF));
-				buffer.put((byte) ((color >>  8) & 0xFF));
-				buffer.put((byte) ((color >>  0) & 0xFF));
-				buffer.put((byte) ((color >> 24) & 0xFF));
-			}
-			
-			buffer.limit(buffer.position()).flip();
-			
-			glTexImage2D(GL_TEXTURE_2D, debugMipmap ? 0 : level, GL_RGBA, newWidth, newHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
-			if(!debugMipmap) {
-				glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAX_LEVEL, level);
-				glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST_MIPMAP_LINEAR);
-			}
-			
-			data = newData;
-			previousWidth = newWidth;
-			
-			newWidth /= 2;
-			newHeight /= 2;
-		}
-	}
-	
-	private int blendColor(int color0, int color1) {
-		int alpha0 = (color0 >> 24) & 0xFF;
-		int alpha1 = (color1 >> 24) & 0xFF;
-		
-		int alphaAvg = (alpha0 + alpha1) / 2;
-		
-		if(alpha0 == 0 && alpha1 == 0) {
-			alpha0 = 1;
-			alpha1 = 1;
-		}else {
-			if(alpha0 == 0) {
-				color0 = color1;
-				alphaAvg /= 2;
-			}
-			if(alpha1 == 0) {
-				color1 = color0;
-				alphaAvg /= 2;
-			}
-		}
 
-		int r0 = (color0 >> 16 & 0xFF) * alpha0;
-		int g0 = (color0 >>  8 & 0xFF) * alpha0;
-		int b0 = (color0 >>  0 & 0xFF) * alpha0;
-		
-		int r1 = (color1 >> 16 & 0xFF) * alpha1;
-		int g1 = (color1 >>  8 & 0xFF) * alpha1;
-		int b1 = (color1 >>  0 & 0xFF) * alpha1;
-		
-		int rAvg = (r0 + r1) / (alpha0 + alpha1);
-		int gAvg = (g0 + g1) / (alpha0 + alpha1);
-		int bAvg = (b0 + b1) / (alpha0 + alpha1);
-		
-		return alphaAvg << 24 | rAvg << 16 | gAvg << 8 | bAvg;
-	}
-	
 	public int createTexture(int width, int height)
 	{
 		int tex = GLAllocation.generateTexture();
@@ -475,14 +191,14 @@ public class RenderEngine {
 		buffer.put(anim.imageData);
 		buffer.position(0).limit(anim.imageData.length);
 
-		anim.texture.parentAtlas.bindTexture();
-		IconCoordinate icon = anim.texture;
+		anim.targetTexture.parentAtlas.bind();
+		IconCoordinate icon = anim.targetTexture;
 
 		int x1 = icon.iconX;
 		int y1 = icon.iconY;
 		glTexSubImage2D(GL_TEXTURE_2D, 0, x1, y1, icon.width, icon.height, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
 		
-		if(mc.gameSettings.mipmapLevels.value > 0) {
+		if(mc.gameSettings.mipmapLevels.value > 0 && anim.targetTexture.parentAtlas.hasMipmaps()) {
 			int levels = glGetTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAX_LEVEL);
 
 			for(int level = 1; level <= levels; level++) {
@@ -547,58 +263,31 @@ public class RenderEngine {
 		glTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, w, h, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
 	}
 
-	public void deleteTexture(int i) {
-		textureNameToImageMap.remove(Integer.valueOf(i));
-		glDeleteTextures(i);
-	}
-
-	public void updateDynamicTextures() {
-        List<DynamicTexture> dynamics = new ArrayList<>(dynamicTextures);
+	public void updateDynamicTextures(boolean isPaused) {
+        List<DynamicTexture> dynamics = new ArrayList<>(dynamicTextures.values());
 		for (DynamicTexture dynamicTexture : dynamics) {
 			try {
-				if (dynamicTexture.runUpdates()) {
+				if (dynamicTexture.runUpdates(isPaused)) {
 					updateDynamicTexture(dynamicTexture);
 				}
 			} catch(Exception e){
-				new RuntimeException("Exception while updating dynamic for '" + dynamicTexture.texture.namespaceId + "'. Removing from dynamic texture pool and skipping!", e).printStackTrace();
-				dynamicTextures.remove(dynamicTexture); // Remove broken texture
+				new RuntimeException("Exception while updating dynamic for '" + dynamicTexture.targetTexture.namespaceId + "'. Removing from dynamic texture pool and skipping!", e).printStackTrace();
+				dynamicTextures.remove(dynamicTexture.targetTexture.namespaceId); // Remove broken texture
 			}
 		}
 	}
 	
 	public BufferedImage getImage(String name) {
 		try {
-			BufferedImage img;
-			if (name.startsWith("##")) {
-				img = unwrapImageByColumns(readImage(texturePacks.getResourceAsStream(name.substring(2))));
-			} else if (name.startsWith("%clamp%")) {
-				clampTexture = true;
-				img = readImage(texturePacks.getResourceAsStream(name.substring(7)));
-			} else if (name.startsWith("%blur%")) {
-				blurTexture = true;
-				img = readImage(texturePacks.getResourceAsStream(name.substring(6)));
-			} else {
-				img = readImage(texturePacks.getResourceAsStream(name));
-			}
-			return img;
+			return readImage(texturePacks.getResourceAsStream(name));
 		}catch (Exception e) {
 			return Textures.missingTexture;
 		}
 	}
-	
-	public void setupTexture(String name) {
-		try {
-			BufferedImage img = getImage(name);
-			int j = textureMap.get(name);
-			setupTexture(img, j);
-			blurTexture = false;
-			clampTexture = false;
-		} catch (Exception e) {
-			e.printStackTrace();
-		}
-	}
-	
+
 	public void refreshTexturesAndDisplayErrors() {
+		MaterialColor.assignManualEntries();
+
     	List<Throwable> errors = new ArrayList<>();
     	
     	refreshTextures(errors);
@@ -668,42 +357,31 @@ public class RenderEngine {
 	 * @param errors A list of errors to be displayed in a popup when selecting the texture pack. Errors of type {@link TexturePackException} will be displayed as a readable message
 	 */
 	public void refreshTextures(List<Throwable> errors) {
-		// Animations may change the size of textures, so they need to be initialized before the atlas is generated
-		initDynamicTextures(errors);
+		CustomAtlasHandler.beforeRefreshTextures();
 		
+		// Animations may change the size of textures, so they need to be initialized before the atlas is generated
+
+		long start = System.nanoTime();
 		for (AtlasStitcher stitcher : TextureRegistry.stitcherMap.values()){
-			stitcher.generateAtlas();
+			stitcher.preinit();
 		}
+		System.out.println("Took '" + (System.nanoTime() - start)/1_000_000_000d + "' seconds to load atlases.");
+
+		initDynamicTextures(errors);
 
-		for (int i=0; i < dynamicTextures.size(); i++) {
-			dynamicTextures.get(i).postInit();
+		for (AtlasStitcher stitcher : TextureRegistry.stitcherMap.values()){
+			stitcher.init();
 		}
 
+        for (DynamicTexture dynamicTexture : dynamicTextures.values()) {
+            dynamicTexture.postInit();
+        }
 
-		
-		textureNameToImageMap.forEach((i, img) -> setupTexture(img, i));
-		textureMap.forEach((name, id) -> setupTexture(name));
-		
-		for (String s : intArrayTextureData.keySet()) {
-			try {
-				BufferedImage img;
-				if (s.startsWith("##")) {
-					img = unwrapImageByColumns(readImage(texturePacks.getResourceAsStream(s.substring(2))));
-				} else if (s.startsWith("%clamp%")) {
-					clampTexture = true;
-					img = readImage(texturePacks.getResourceAsStream(s.substring(7)));
-				} else if (s.startsWith("%blur%")) {
-					blurTexture = true;
-					img = readImage(texturePacks.getResourceAsStream(s.substring(6)));
-				} else {
-					img = readImage(texturePacks.getResourceAsStream(s));
-				}
-				getImageData(img, intArrayTextureData.get(s));
-				blurTexture = false;
-				clampTexture = false;
-			} catch (Exception ioexception1) {
-				ioexception1.printStackTrace();
-			}
+		for (BufferedTexture t : bufferedTextures) {
+			t.init();
+		}
+		for (Texture t : textureMap.values()) {
+			t.init();
 		}
 
 		Colors.loadColors();
@@ -719,40 +397,41 @@ public class RenderEngine {
         mc.worldRenderer.lightmapHelper.setup();
 	}
 
-	public void bindTexture(int i) {
-		if (i < 0) return;
-		glBindTexture(GL_TEXTURE_2D, i);
+	public void bindTexture(Texture texture) {
+		if (texture == null) return;
+		texture.bind();
 	}
-	
-	public Map<String, Integer> getTextureMap() {
-		return textureMap;
+
+	public void bindTexture(int textureID) {
+		if (textureID < 0) return;
+		GL11.glBindTexture(GL_TEXTURE_2D, textureID);
 	}
 
-	public boolean loadDownloadableTexture(String url, String localTexture, ImageParser imageParser) {
-		if(url == null) {
-			if(localTexture != null) {
-				bindTexture(getTexture(localTexture));
+	public boolean bindDownloadableTexture(String urlTexture, String backupTexture, ImageParser imageParser) {
+		if(urlTexture == null) {
+			if(backupTexture != null) {
+				bindTexture(loadTexture(backupTexture));
 				return true;
 			}else {
 				return false;
 			}
 		}
-		DownloadedTexture texture = downloadedTextures.get(url);
+		DownloadedTexture texture = downloadedTextures.get(urlTexture);
 		if(texture == null) {
-			texture = new DownloadedTexture(url, imageParser);
-			downloadedTextures.put(url, texture);
+			texture = new DownloadedTexture(urlTexture, imageParser);
+			downloadedTextures.put(urlTexture, texture);
 		}
-		if(texture.textureId < 0) {
+		if(!texture.isGenerated()) {
 			if(texture.image != null) {
-				texture.textureId = allocateAndSetupTexture(texture.image);
+				texture.generate();
+				texture.setupTexture(texture.image, false, false, false);
 			}
 		}
-		if(texture.textureId > 0) {
-			bindTexture(texture.textureId);
+		if(texture.bind()) {
 			return true;
 		}else {
-			if(localTexture != null) {
-				bindTexture(getTexture(localTexture));
+			if(backupTexture != null) {
+				bindTexture(loadTexture(backupTexture));
 				return true;
 			}else {
 				return false;
